  MEMBER
  include('zError.Inc')

zErrorFileName string(255),static
zErrorFile  FILE,DRIVER('ASCII'),CREATE,NAME(zErrorFileName)
                RECORD
Txt               STRING(1024)
                END
              END


zErrorLogClass.Destruct PROCEDURE

  CODE
  if self.usage then SELF.Close(True).

zErrorLogClass.PrimeRecord PROCEDURE(STRING Txt)
  Code
  zErrorFile.Txt   = txt

zErrorLogClass.Open PROCEDURE(BYTE Force)

  CODE
    If Self.LogFile &= Null
      Self.LogFile &= zErrorFile
    End
    If self.LogFileName = '' then self.LogFileName = 'zError.Log'.
    zErrorFileName = self.LogFileName
    OPEN(Self.Logfile, 42h)                     !Read/write deny none
    case errorcode()
    of 2
      CREATE(Self.Logfile)
      OPEN(Self.Logfile, 42h)                     !Read/write deny none
    End
    If ERRORCODE() and errorcode() <> 52         ! File Already Open
      RETURN Level:Notify
    Else
      Self.Usage += 1
      RETURN Level:Benign
    End


zErrorLogClass.Close PROCEDURE(BYTE Force)

  CODE
  IF SELF.Usage = 1 OR Force
    Close(Self.Logfile)
    IF ERRORCODE() THEN RETURN Level:Notify.
    SELF.Usage = 1
  END
  SELF.Usage -= 1
  RETURN Level:Benign


zErrorLogClass.ErrorLogInterface.Take PROCEDURE(STRING Txt)

  CODE
  IF SELF.Usage = 0
    Self.ErrorLogInterface.Open(True)
  End
  IF SELF.Usage = 0 then Return Level:Notify.
  Self.PrimeRecord(Txt)
  ADD(Self.LogFile)
  RETURN CHOOSE(ERRORCODE() = 0, Level:Benign, Level:Notify)

zErrorLogClass.ErrorLogInterface.Open PROCEDURE(BYTE Force)

  CODE
  RETURN SELF.Open(Force)


zErrorLogClass.ErrorLogInterface.Close PROCEDURE(BYTE Force)

  CODE
  RETURN SELF.Close(Force)
